      SUBROUTINE MNB9R(N,X,S,XX,EPS,H,A,B,FA,FB,K,FUN,IERR)
         INTEGER IERR,K,N
         REAL A,B,EPS,FA,FB,H,S,X,XX
         DIMENSION S(N),X(N),XX(N)
         INTEGER I
         REAL ALFA,F,F0,F1,F2,FE,Y,Y0,Y1,Y2,Z0,Z1,Z2
       K = 0
       Y0 = 0.
       ALFA = 0.
       CALL FUN(X,F0,FE)
       K = K + 1
   10  CONTINUE
       Y = Y0 + EPS
       DO 20 I = 1, N
          XX(I) = X(I) + Y*S(I)
   20  CONTINUE
       CALL FUN(XX,F,FE)
       K = K + 1
       IF (F .NE. F0) GO TO 50
          IF (EPS) 30, 30, 40
   30  CONTINUE
       IERR = 66
       GO TO 180
   40  CONTINUE
       EPS = -EPS
       GO TO 10
   50  CONTINUE
       IF (F - F0) 60, 60, 70
   60  CONTINUE
       Y1 = Y
       F1 = F
       GO TO 80
   70  CONTINUE
       Y1 = Y0
       F1 = F0
       Y0 = Y
       F0 = F
       ALFA = ALFA + EPS
   80  CONTINUE
       EPS = EPS + EPS
       IF (ABS(ALFA) - H) 90, 90, 110
   90  CONTINUE
       Y2 = Y1 + EPS
       DO 100 I = 1, N
          XX(I) = X(I) + Y2*S(I)
  100  CONTINUE
       CALL FUN(XX,F2,FE)
       K = K + 1
       Z0 = X(1) + Y0
       Z1 = X(1) + Y1
       Z2 = X(1) + Y2
       GO TO 130
  110  CONTINUE
       Y2 = H
       IF (EPS .LT. 0.) Y2 = -H
       DO 120 I = 1, N
          XX(I) = X(I) + Y2*S(I)
  120  CONTINUE
       CALL FUN(XX,F2,FE)
       K = K + 1
       Z0 = X(1) + Y0
       Z1 = X(1) + Y1
       Z2 = X(1) + Y2
       IERR = 65
       GO TO 140
  130  CONTINUE
       IF (F2 .GE. F1) GO TO 140
          Y0 = Y1
          F0 = F1
          Y1 = Y2
          F1 = F2
          ALFA = ALFA + EPS
          GO TO 80
  140  CONTINUE
       IF (EPS) 150, 150, 160
  150  CONTINUE
       A = Y2
       FA = F2
       B = Y0
       FB = F0
       GO TO 170
  160  CONTINUE
       A = Y0
       FA = F0
       B = Y2
       FB = F2
  170  CONTINUE
       IERR = 0
  180  RETURN
      END
